library DigiClock;

uses
  Windows,
  Messages,
  FNxxx in '..\..\FNxxx.pas',
  AstonSDK in '..\..\AstonSDK.pas',
  st_api in '..\..\st_api.pas';

{---------------------------------------------------------------------}

{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\plg.pas}
{$ENDIF}

{$IMAGEBASE $00400000}


{---------------------------------------------------------------------}
const
 Name:array[0..3] of char = 'DDT'#0;
 szClassName = 'DDT';
 Dsk:PChar = 'DDT 1.1'#13#10#13#10'Digital Desktop Time for Aston Shell'#13#10'2004 by Risko';
 szXPos = 'XPos';
 szYPos = 'YPos';
 szLock = 'Lock';
 szColor = 'Color';
 szSize = 'Size';
 szAMPM = '24/12 Format';
 szShowAMPM = 'Show AM/PM';
 szSupZero = 'Suppres zeros';
 cKeyCount = 8;
 WallKeys:array[1..cKeyCount] of TKey = (
    (szKey:szXPos; nType:KEY_INT; szHint:szXPos; vDefault:10; res1:0; res2:0),
    (szKey:szYPos; nType:KEY_INT; szHint:szYPos; vDefault:10; res1:0; res2:0),
    (szKey:szSize; nType:KEY_INT; szHint:szSize; vDefault:276; res1:0; res2:0),
    (szKey:szColor; nType:KEY_COLOR; szHint:szColor; vDefault:$000000; res1:0; res2:0),
    (szKey:szAMPM; nType:KEY_BOOL; szHint:szAMPM; vDefault:0; res1:0; res2:0),
    (szKey:szShowAMPM; nType:KEY_BOOL; szHint:szShowAMPM; vDefault:0; res1:0; res2:0),
    (szKey:szSupZero; nType:KEY_BOOL; szHint:szSupZero; vDefault:0; res1:0; res2:0),
    (szKey:szLock; nType:KEY_BOOL; szHint:szLock; vDefault:0; res1:0; res2:0));

var
  AData: TAstonData;
  PluginInfo:TPluginInfo;
  ChildWindow:hWnd=0;
  ClientRC:TRect;
  XPos, YPos, XSize: integer;
  bAMPM: boolean;
  bShowAMPM: boolean;
  bSupZero: boolean;
  hBrushRed: HBRUSH;
  nHeight: integer;
  cxClient: integer;
  cyClient: integer;
  bLock: boolean;
  Color : HColorSpace;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure SavePos;
var
  CFG:TCFG;
  r:TRect;
begin
  OpenCFGw(AData.PluginsCFG, @CFG);
  FindSection(szClassName, SECTION_CREATE_ALWAYS, @CFG);
  GetWindowRect(ChildWindow, r);
  XPos:=r.Left;
  YPos:=r.Top;
  SetCFGInt(szXPos, XPos, @CFG);
  SetCFGInt(szYPos, YPos, @CFG);
  CloseCFGw(AData.PluginsCFG, false, @CFG);
end;

{---------------------------------------------------------------------}

procedure DisplayDigit(hdc: HDC;  iNumber: integer); 
const
  fSevenSegment : array [0..11,0..6] of byte = ((1,1,1,0,1,1,1), //0
                                              (0,0,1,0,0,1,0),   //1
                                              (1,0,1,1,1,0,1),   //2
                                              (1,0,1,1,0,1,1),   //3
                                              (0,1,1,1,0,1,0),   //4
                                              (1,1,0,1,0,1,1),   //5
                                              (1,1,0,1,1,1,1),   //6
                                              (1,0,1,0,0,1,0),   //7
                                              (1,1,1,1,1,1,1),   //8
                                              (1,1,1,1,0,1,1),   //9
                                              (1,1,1,1,1,1,0),   //A
                                              (1,1,1,1,1,0,0));  //P
  ptSegment : array [0..6,0..5] of TPoint = (((x:7;y:6),(x:11;y:2),(x:31;y:2),(x:35;y:6),(x:31;y:10),(x:11;y:10)),
                                            ((x:6;y:7),(x:10;y:11),(x:10;y:31),(x:6;y:35),(x:2;y:31),(x:2;y:11)),
                                            ((x:36;y:7),(x:40;y:11),(x:40;y:31),(x:36;y:35),(x:32;y:31),(x:32;y:11)),
                                            ((x:7;y:36),(x:11;y:32),(x:31;y:32),(x:35;y:36),(x:31;y:40),(x:11;y:40)),
                                            ((x:6;y:37),(x:10;y:41),(x:10;y:61),(x:6;y:65),(x:2;y:61),(x:2;y:41)),
                                            ((x:36;y:37),(x:40;y:41),(x:40;y:61),(x:36;y:65),(x:32;y:61),(x:32;y:41)),
                                            ((x:7;y:66),(x:11;y:62),(x:31;y:62),(x:35;y:66),(x:31;y:70),(x:11;y:70)));
var iSeg: integer;
begin
  for iSeg:=0 to 6
  do
  if fSevenSegment[iNumber][iSeg] = 1
  then
  Polygon(hdc,ptSegment[iSeg],6);
end;

{---------------------------------------------------------------------}

procedure DisplayTwoDigits(hdc: HDC;  iNumber: integer;  fSuppress: BOOL); 
begin
  if (not(fSuppress) or (iNumber div 10 <> 0)) then DisplayDigit(hdc,iNumber div 10);
  OffsetWindowOrgEx(hdc,-42,0,nil);
  DisplayDigit(hdc,iNumber mod 10);
  OffsetWindowOrgEx(hdc,-42,0,nil);
end;

{---------------------------------------------------------------------}

procedure DisplayColon(hdc: HDC); 
const
  ptColon : array [0..1,0..3] of TPoint = (((x:2;y:21),(x:6;y:17),(x:10;y:21),(x:6;y:25)),
                                           ((x:2;y:51),(x:6;y:47),(x:10;y:51),(x:6;y:55)));
begin
  Polygon(hdc,ptColon[0],4);
  Polygon(hdc,ptColon[1],4); 
  OffsetWindowOrgEx(hdc,-12,0,nil);
end;

{---------------------------------------------------------------------}

procedure DisplayTime(hdc: HDC;  bAMPMF: BOOL;  fSuppress: BOOL);
var
st: SYSTEMTIME; 
begin
  GetLocalTime(st);
  if not bAMPMF then DisplayTwoDigits(hdc,st.wHour,fSuppress)
  else if (st.wHour mod 12) = 0 then DisplayTwoDigits(hdc,12,fSuppress)
    else DisplayTwoDigits(hdc,st.wHour mod 12,fSuppress);
  DisplayColon(hdc); 
  DisplayTwoDigits(hdc,st.wMinute,LongBool(0));
  DisplayColon(hdc); 
  DisplayTwoDigits(hdc,st.wSecond,LongBool(0));
  if bShowAMPM then
  begin
    OffsetWindowOrgEx(hdc,-6,0,nil);
    if st.wHour>12 then DisplayDigit(hdc,11)
    else DisplayDigit(hdc,10);
  end;
end;

{---------------------------------------------------------------------}

function Ceil(const X: Extended): Integer;
begin
  Result := Integer(Trunc(X));
  if Frac(X) > 0 then
    Inc(Result);
end;

{---------------------------------------------------------------------}

function WindowProc(Window: HWnd; Message:UINT; WParam: WParam;
  LParam: LParam): Longint;  stdcall;
var
  DC: hDC;
  ps: TPaintStruct;
  r, r2:Trect;
  uFlags:UINT;
begin
  result := 0;
  case Message of

    WM_CREATE:
    begin
      hBrushRed:= CreateSolidBrush(Color);
      SetTimer(Window,1,1000,nil);
    end;

    WM_TIMER:
    begin
      InvalidateRect(Window,nil,LongBool(1));
      exit;
    end;

    WM_SETTINGCHANGE:
    begin
      InvalidateRect(Window,nil,LongBool(1));
      exit;
    end;

    WM_PAINT:
    begin
      DC:=BeginPaint(Window, ps);
      GetClientRect(Window, ClientRC);
      GetWindowRect(Window, r);
      SetRect(r2, 0,0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
      uFlags:= DPEx_CORRECTBRUSH;
      with AData.WallPaperInfo do
      begin
        if TileWallpaper<>0 then uFlags:= uFlags or DPEx_TILED;
        if WallpaperStyle=0 then uFlags:= uFlags or DPEx_CENTERED;
        DrawSkin(DC, DC, ClientRC, r, r2, Wallpaper, DesktopBrush, uFlags);
      end;
      //DrawEdge(DC, ClientRC, BDR_SUNKENOUTER, BF_RECT); //to show window boundaries
      SetMapMode(DC,MM_ISOTROPIC);
      SetWindowExtEx(DC,nHeight,72,nil);
      SetViewportExtEx(DC,cxClient,cyClient,nil);
      SetWindowOrgEx(DC,nHeight div 2,36,nil);
      SetViewportOrgEx(DC,cxClient div 2,cyClient div 2,nil);
      SelectObject(DC,GetStockObject(NULL_PEN));
      SelectObject(DC,hBrushRed);
      DisplayTime(DC,bAMPM,bSupZero);
      EndPaint(Window,ps);
      exit;
    end;

    WM_DESTROY:
    begin
      KillTimer(Window,1); 
      DeleteObject(hBrushRed);
      exit;
    end;

    WM_SIZE:
    begin
      cxClient:= LOWORD(lParam); 
      cyClient:= HIWORD(lParam); 
      exit;
    end;

    WM_ERASEBKGND:
    begin
      result:= 1;
      exit;
    end;

    WM_ENTERSIZEMOVE:
    begin
      SetWindowLong(Window, GWL_EXSTYLE, GetWindowLong(Window, GWL_EXSTYLE) and not WS_EX_TRANSPARENT);
    end;

    WM_MOVING:
    begin
      InvalidateRect(Window, nil, false);
    end;

    WM_EXITSIZEMOVE:
    begin
      SavePos;
      SetWindowLong(Window, GWL_EXSTYLE, GetWindowLong(Window, GWL_EXSTYLE) or WS_EX_TRANSPARENT);
      InvalidateRect(Window, nil, false);
    end;

    WM_NCHITTEST:
    begin
      DefWindowProc(Window, Message, WParam, LParam);
      if bLock then
        result:=HTCLIENT
      else
        result:=HTCAPTION;
      exit;
    end;

  end;
  result := DefWindowProc(Window, Message, WParam, LParam);
end;

{---------------------------------------------------------------------}

procedure ReadConfig;
var
  CFG:TCFG;
begin
  OpenCFGr(AData.PluginsCFG, @CFG);
  FindSection(szClassName, 0, @CFG);
  XPos:=GetCFGInt(szXPos, 1, @CFG);
  CheckInt(XPos, 0, GetSystemMetrics(SM_CXSCREEN)-8, 0);
  YPos:=GetCFGInt(szYPos, 1, @CFG);
  CheckInt(YPos, 0, GetSystemMetrics(SM_CYSCREEN)-8, 0);
  XSize:=GetCFGInt(szSize, 276, @CFG);
  CheckInt(XSize, 0, GetSystemMetrics(SM_CXSCREEN)-8, 276);
  Color:=GetCFGHex(szColor, $000000, @CFG);
  bAMPM := GetCFGBool(szAMPM, FALSE, @CFG);
  bShowAMPM := GetCFGBool(szShowAMPM, FALSE, @CFG);
  bSupZero := GetCFGBool(szSupZero, FALSE, @CFG);
  bLock := GetCFGBool(szLock, FALSE, @CFG);
  CloseCFGr(@CFG);
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
  WindowClass:TWndClass;
begin
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));
  RtlZeroMemory(@WindowClass, sizeOf(TWndClass));
  WindowClass.style:=CS_HREDRAW or CS_VREDRAW;
  WindowClass.hCursor := LoadCursor(0, IDC_ARROW);
  WindowClass.hInstance := hInstance;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.lpszClassName:= szClassName;
  if RegisterClass(WindowClass) = 0 then exit;

  ReadConfig;
  if bShowAMPM then nHeight:=324 else nHeight:=276;

  ChildWindow:= CreateWindowEx(WS_EX_TRANSPARENT,
    szClassName,
    nil,
    WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or WS_CLIPCHILDREN,
    XPos, YPos,
    XSize, Ceil(XSize/nHeight*72),
    AData.Desktop,
    0,
    hInstance,
    nil);

  AData.Node.Wnd:= ChildWindow;
  GetClientRect(ChildWindow, ClientRC);
end;

{---------------------------------------------------------------------}

procedure DoneModule; stdcall;
begin
  if ChildWindow<>0 then
  begin
    DestroyWindow(ChildWindow);
    ChildWindow:=0;
  end;
  UnregisterClass(szClassName, hInstance);
end;

{---------------------------------------------------------------------}

function GetPluginInfo:PPluginInfo;stdcall;
begin
 PluginInfo.cbSize:=SizeOf(TPluginInfo);
 PluginInfo.szName:=Name;
 PluginInfo.szDescription:=Dsk;
 PluginInfo.szSection:=Name;
 PluginInfo.nKeyCount:=cKeyCount;
 PluginInfo.Keys:=@WallKeys;
 result:=@PluginInfo;
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

exports
  InitGlobalModule,
  DoneModule,
  GetPluginInfo;
end.
